using PlumbingRepairBusinessLogic.OfficePackage.HelperEnums;
using PlumbingRepairBusinessLogic.OfficePackage.HelperModels;

namespace PlumbingRepairBusinessLogic.OfficePackage
{
    public abstract class AbstractSaveToWord
    {
        public void CreateDoc(WordInfo info)
        {
            CreateWord(info);
            CreateParagraph(new WordParagraph
            {
                Texts = new List<(string, WordTextProperties)> { 
                    (info.Title, new WordTextProperties { Bold = true, Size = "24", }) 
                },
                TextProperties = new WordTextProperties
                {
                    Size = "24",
                    JustificationType = WordJustificationType.Center
                }
            });
            foreach (var work in info.Works)
            {
                CreateParagraph(new WordParagraph
                {
                    Texts = new List<(string, WordTextProperties)> { 
                        (work.WorkName, new WordTextProperties { Bold = true, Size = "24" }), 
                        ($"  {work.Price}", new WordTextProperties { Size = "24", JustificationType = WordJustificationType.Right }) },
                    TextProperties = new WordTextProperties
                    {
                        Size = "24",
                        JustificationType = WordJustificationType.Both
                    }
                });
            }
            SaveWord(info);
        }

        protected abstract void CreateWord(WordInfo info);

        protected abstract void CreateParagraph(WordParagraph paragraph);

        protected abstract void SaveWord(WordInfo info);
    }
}
